/*---------------------------------------------------------------------------------------------------------------------------------------------------
 * PageFragment.java - Page Fragment class
 *
 * Copyright (c) 2014 Frank Meyer - frank(at)fli4l.de
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *---------------------------------------------------------------------------------------------------------------------------------------------------
 */

package com.voice_tour.remotebutler;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.SocketException;
import java.net.SocketTimeoutException;
import java.net.UnknownHostException;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.res.Resources;
import android.graphics.Color;
import android.graphics.LightingColorFilter;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.text.InputType;
import android.util.TypedValue;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.ScrollView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.AdapterView.OnItemSelectedListener;


public class PageFragment extends Fragment
{
	public static int				NUM_PAGES = 5;
    private static String[]			pagetext = { "Fernseher", "Satelliten-Empfnger", "DVD-Player", "CD-Player", "Radio" };  

	private int						fragno;
	private Context					MainActivityContext;

	public static String			ButtonsXmlFile = "Buttons.xml";
	static final int				LINES = 20;
	static final int				COLS_PER_LINE = 3;
	static final int				HEIGHT_INVISIBLE_BUTTON = 30; // 30;
	static final int				BUTTONS = LINES * COLS_PER_LINE;
	static final int				BUTTON_WIDTH = 110;			// Width in dip, converted in pixels
	static boolean					EditMode = false; 

	Resources						r;
    TextView						tvpagetext;
    EditText						etpagetext;
    
	private	Button					SaveButton; 
	
	private static RemoteButton[]	remote_buttons		= new RemoteButton[NUM_PAGES * BUTTONS];
	
	private int						current_idx;
	private String					current_text;
	private int						current_color;
	private IrmpData				current_IrmpData = new IrmpData();

	public static PageFragment newInstance(int nr)
	{
		PageFragment myFragment = new PageFragment();

	    Bundle args = new Bundle();
	    args.putInt("fragno", nr);
	    myFragment.setArguments(args);

	    return myFragment;
	}

	private void SetButton (int page, int bidx, boolean v, String t, int c)
	{
		RemoteButton rb = remote_buttons[BUTTONS * page + bidx];

		rb.visible	   	= v;
		rb.text		   	= t;
		rb.color	   	= c;
		rb.serveridx  	= 0;
		rb.protocol	   	= 3;
		rb.address		= 1234;
		rb.command		= bidx;
		rb.flags		= 0;
	}

	@Override
    public void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		
		this.fragno = getArguments().getInt("fragno", 0);

		if (remote_buttons[0] == null)
		{
			int n = 0;
			
			n = RemoteButton.loadButtons(pagetext, remote_buttons, NUM_PAGES, BUTTONS, MainActivity.remotebutlerpath, ButtonsXmlFile);

			if (n == 0)
			{
				for (int i = 0; i < NUM_PAGES; i++)
				{
					for (int j = 0; j < BUTTONS; j++)
					{
						remote_buttons[BUTTONS * i + j] = new RemoteButton();
					}
				}

				SetButton (0,  0, true, "STUMM", RemoteButton.BLUE);
		        SetButton (0,  2, true, "POWER", RemoteButton.RED);
		
		        SetButton (0,  6, true, "1",     RemoteButton.GRAY);
		        SetButton (0,  7, true, "2",     RemoteButton.GRAY);
		        SetButton (0,  8, true, "3",     RemoteButton.GRAY);
		        SetButton (0,  9, true, "4",     RemoteButton.GRAY);
		        SetButton (0, 10, true, "5",     RemoteButton.GRAY);
		        SetButton (0, 11, true, "6",     RemoteButton.GRAY);
		        SetButton (0, 12, true, "7",     RemoteButton.GRAY);
		        SetButton (0, 13, true, "8",     RemoteButton.GRAY);
		        SetButton (0, 14, true, "9",     RemoteButton.GRAY);
		        SetButton (0, 16, true, "0",     RemoteButton.GRAY);
		        
		        SetButton (0, 22, true, "Ch+",   RemoteButton.DKGRAY);
		        SetButton (0, 24, true, "<",  	RemoteButton.DKGRAY);
		        SetButton (0, 26, true, ">", 	RemoteButton.DKGRAY);
		        SetButton (0, 28, true, "Ch-",	RemoteButton.DKGRAY);
		
		        SetButton (0, 33, true, "<<",  	RemoteButton.GRAY);
		        SetButton (0, 34, true, "TEXT", 	RemoteButton.GREEN);
		        SetButton (0, 35, true, ">>", 	RemoteButton.GRAY);

		        SetButton (1,  0, true, "MEN",  RemoteButton.GRAY);
		        SetButton (1,  2, true, "POWER", RemoteButton.RED);

		        SetButton (1, 16, true, "UP",    RemoteButton.DKGRAY);
		        SetButton (1, 18, true, "LEFT",  RemoteButton.DKGRAY);
		        SetButton (1, 20, true, "RIGHT", RemoteButton.DKGRAY);
		        SetButton (1, 22, true, "DOWN",  RemoteButton.DKGRAY);

				SetButton (2,  0, true, "EJECT", RemoteButton.BLUE);
		        SetButton (2,  1, true, "MEN",  RemoteButton.GRAY);
		        SetButton (2,  2, true, "POWER", RemoteButton.RED);

		        SetButton (2, 16, true, "+",   	RemoteButton.DKGRAY);
		        SetButton (2, 18, true, "<",  	RemoteButton.DKGRAY);
		        SetButton (2, 20, true, ">", 	RemoteButton.DKGRAY);
		        SetButton (2, 22, true, "-",  	RemoteButton.DKGRAY);

		        SetButton (2, 27, true, "<<",	RemoteButton.GRAY);
		        SetButton (2, 29, true, ">>",	RemoteButton.GRAY);
		        SetButton (2, 30, true, "START", RemoteButton.GREEN);
		        SetButton (2, 31, true, "STOP",  RemoteButton.RED);
		        SetButton (2, 32, true, "PAUSE", RemoteButton.BLUE);
		        SetButton (2, 33, true, "|<<",	RemoteButton.GRAY);
		        SetButton (2, 35, true, ">>|",	RemoteButton.GRAY);

				SetButton (3,  0, true, "EJECT", RemoteButton.BLUE);
		        SetButton (3,  1, true, "MEN",  RemoteButton.GRAY);
		        SetButton (3,  2, true, "POWER", RemoteButton.RED);
		
		        SetButton (3, 16, true, "Tr +",  RemoteButton.DKGRAY);
		        SetButton (3, 18, true, "Vol -", RemoteButton.DKGRAY);
		        SetButton (3, 20, true, "Vol +", RemoteButton.DKGRAY);
		        SetButton (3, 22, true, "Tr -",	RemoteButton.DKGRAY);
		
		        SetButton (3, 27, true, "<<",	RemoteButton.GRAY);
		        SetButton (3, 29, true, ">>",	RemoteButton.GRAY);
		        SetButton (3, 30, true, "START", RemoteButton.GREEN);
		        SetButton (3, 31, true, "STOP",  RemoteButton.RED);
		        SetButton (3, 32, true, "PAUSE", RemoteButton.BLUE);
		        SetButton (3, 33, true, "|<<",	RemoteButton.GRAY);
		        SetButton (3, 35, true, ">>|",	RemoteButton.GRAY);

		        SetButton (4,  0, true, "SCAN",  RemoteButton.GRAY);
		        SetButton (4,  2, true, "POWER", RemoteButton.RED);
		
		        SetButton (4,  6, true, "1",     RemoteButton.GRAY);
		        SetButton (4,  7, true, "2",     RemoteButton.GRAY);
		        SetButton (4,  8, true, "3",     RemoteButton.GRAY);
		        SetButton (4,  9, true, "4",     RemoteButton.GRAY);
		        SetButton (4, 10, true, "5",     RemoteButton.GRAY);
		        SetButton (4, 11, true, "6",     RemoteButton.GRAY);
		        SetButton (4, 12, true, "7",     RemoteButton.GRAY);
		        SetButton (4, 13, true, "8",     RemoteButton.GRAY);
		        SetButton (4, 14, true, "9",     RemoteButton.GRAY);
		        SetButton (4, 16, true, "0",     RemoteButton.GRAY);
		        
		        SetButton (4, 24, true, "<",		RemoteButton.DKGRAY);
		        SetButton (4, 26, true, ">",		RemoteButton.DKGRAY);
			}
			else
			{
				for (int i = 0; i < NUM_PAGES; i++)
				{
					for (int j = 0; j < BUTTONS; j++)
					{
						if (remote_buttons[BUTTONS * i + j] == null)
						{
							remote_buttons[BUTTONS * i + j] = new RemoteButton();
						}
					}
				}
			}
		}
	}
	
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState)
    {
    	MainActivityContext = getActivity();

        ScrollView sv = new ScrollView(MainActivityContext);
        LinearLayout ll = new LinearLayout(MainActivityContext);
        ll.setOrientation(LinearLayout.VERTICAL);

    	LinearLayout xle = new LinearLayout(MainActivityContext);
    	xle.setOrientation(LinearLayout.HORIZONTAL);
    	xle.setGravity(Gravity.CENTER_HORIZONTAL);

        r = getResources();
        int button_width_px = (int) (TypedValue.applyDimension(TypedValue.COMPLEX_UNIT_DIP, BUTTON_WIDTH, r.getDisplayMetrics()) + 0.5);

        SaveButton = new Button(MainActivityContext);
        // SaveButton.setGravity(Gravity.END);
        SaveButton.setTextColor (Color.WHITE);
        SaveButton.setText("Speichern");

        SaveButton.setOnClickListener(new OnClickListener()
    	{
    		@Override
    		public void onClick(View v)
    		{
				tvpagetext.setText(etpagetext.getText ());
				MainActivity.setEditMode (false);
				pagetext[fragno] = etpagetext.getText().toString().trim();
				RemoteButton.saveButtons(pagetext, remote_buttons, NUM_PAGES, BUTTONS, MainActivity.remotebutlerpath, ButtonsXmlFile);
    		}
     
    	});

        SaveButton.setVisibility(View.INVISIBLE);
        xle.addView(SaveButton);

        ll.addView(xle);

        tvpagetext = new TextView(MainActivityContext);
        tvpagetext.setText(pagetext[fragno]);
        tvpagetext.setTextColor(Color.WHITE);
        tvpagetext.setGravity(Gravity.CENTER_HORIZONTAL);
        ll.addView(tvpagetext);

        etpagetext = new EditText(MainActivityContext);
        etpagetext.setText(pagetext[fragno]);
        etpagetext.setTextColor(Color.WHITE);
        etpagetext.setBackgroundColor(Color.TRANSPARENT);
        etpagetext.setVisibility(View.VISIBLE);
		ll.addView(etpagetext);

		ll.setOnLongClickListener(new OnLongClickListener()
    	{
    		@Override
    		public boolean onLongClick(View v)
    		{
     		   Toast.makeText(MainActivityContext, "Long Click", Toast.LENGTH_SHORT).show();
     		   return true;
    		}
     
    	});

		for(int row = 0; row < LINES; row++)
        {
        	LinearLayout xl = new LinearLayout(MainActivityContext);
        	xl.setOrientation(LinearLayout.HORIZONTAL);
        	xl.setGravity(Gravity.CENTER_HORIZONTAL);

            r = getResources();
            button_width_px = (int) (TypedValue.applyDimension(TypedValue.COMPLEX_UNIT_DIP, BUTTON_WIDTH, r.getDisplayMetrics()) + 0.5);

            for(int col = 0; col < COLS_PER_LINE; col++)
        	{
	            int bidx = COLS_PER_LINE * row + col;
				RemoteButton rb = remote_buttons[BUTTONS * fragno + bidx]; 

				rb.button = new Button(MainActivityContext);
				rb.button.setId(bidx + 2000 + 100 * fragno);

				rb.button.setWidth(button_width_px);
				rb.button.setGravity(Gravity.CENTER);		// center text! not button!
				rb.button.setTextColor (Color.WHITE);
	            
	            if (rb.visible)
	            {
	            	rb.button.setText(rb.text);
	            	rb.button.getBackground().setColorFilter(
	            			new LightingColorFilter(RemoteButton.MUL[rb.color], RemoteButton.COL[rb.color]));
	            }
	            else
	            {
	            	rb.button.setText("");
	            	rb.button.getBackground().setColorFilter(
	            			new LightingColorFilter(RemoteButton.MUL[RemoteButton.INVISIBLE],
	            									RemoteButton.COL[RemoteButton.INVISIBLE]));
	            }

	            rb.button.setOnClickListener(new OnClickListener()
	        	{
	        		@Override
	        		public void onClick(View v)
	        		{
						int id = v.getId();
	        			int button_idx = id - 2000 - 100 * fragno;
        				RemoteButton rbclicked = remote_buttons[BUTTONS * fragno + button_idx]; 
	        			
	        			if (EditMode)
	        			{
	        				if (rbclicked.visible)
	        				{
			        			editButton (button_idx);
	        				}
		        			else
		        			{
			        			Button b = (Button) ((MainActivity) (MainActivityContext)).myfindViewById (id);
		        				SetButton (fragno, button_idx, true, "Btn " + (button_idx + 1), RemoteButton.DKGRAY);
			        			b.setText(rbclicked.text);
		        				b.getBackground().setColorFilter(
		        							new LightingColorFilter(RemoteButton.MUL[rbclicked.color],
		        													RemoteButton.COL[rbclicked.color]));
			        			// Toast.makeText(MainActivityContext, "Sichtbar " + fragno + " " + button_idx, Toast.LENGTH_SHORT).show();
		        			}
	        			}
	        			else
	        			{
		        			if (rbclicked.visible)
		        			{
			        			// StringBuffer result = new StringBuffer();
		        				// result.append(rbclicked.text);
		        				// Toast.makeText(MainActivityContext, result.toString(), Toast.LENGTH_SHORT).show();

		            		    DatagramSocket s;

		            		    byte[] sendData = new byte[7];

		            		    sendData[0] = 'S';
		            		    sendData[1] = (byte) (rbclicked.protocol & 0xFF);
		            		    sendData[2] = (byte) ((rbclicked.address >> 8) & 0xFF);
		            		    sendData[3] = (byte) (rbclicked.address & 0xFF);
		            		    sendData[4] = (byte) ((rbclicked.command >> 8) & 0xFF);
		            		    sendData[5] = (byte) (rbclicked.command & 0xFF);
		            		    sendData[6] = 0x00;			// flags: TODO
		            		    
		            		    try
		            			{
		            				s = new DatagramSocket();

		            				InetAddress RemoteServer = InetAddress.getByName(MainActivity.irmp_server[rbclicked.serveridx].ipaddress);  
			            		    int server_port = MainActivity.irmp_server[rbclicked.serveridx].port;  
		            			      
		            			    int msg_length = 7;
		            			    DatagramPacket p = new DatagramPacket(sendData, msg_length, RemoteServer, server_port);  
		            			      
		            			    s.send(p);
		            			    
		            			    byte[] receiveData = new byte[2];

		            			    s.setSoTimeout(500);   			// set the timeout in millisecounds: 0.5 sec
		            	            DatagramPacket receivePacket = new DatagramPacket(receiveData, receiveData.length);
		            			    
		            			    try
		            			    {
		            			    	s.receive(receivePacket);

		            			    	if (receivePacket.getLength() != 2 || receiveData[0] != 'S' || receiveData[1] != '+')
		            			    	{
			            			    	Toast.makeText(MainActivityContext.getApplicationContext(), "Antwort: Unbekanntes Protokoll!", Toast.LENGTH_SHORT).show();
		            			    	}
		            			    }
		            			    catch (SocketTimeoutException e)
		            			    {
		            			    	Toast.makeText(MainActivityContext.getApplicationContext(), "Keine Antwort!", Toast.LENGTH_SHORT).show();
		            	            }
		           			    	s.close();
		            			}
		            			catch (SocketException e)
		            			{
	            			    	Toast.makeText(MainActivityContext.getApplicationContext(), "Socket exception!", Toast.LENGTH_SHORT).show();
		            				e.printStackTrace();
		            			}
		            		    catch (UnknownHostException e)
		            			{
	            			    	Toast.makeText(MainActivityContext.getApplicationContext(), "Unknown host!", Toast.LENGTH_SHORT).show();
		            				e.printStackTrace();
		            			}
		            		    catch (IOException e)
		            		    {
	            			    	Toast.makeText(MainActivityContext.getApplicationContext(), "IO exception!", Toast.LENGTH_SHORT).show();
		            				e.printStackTrace();
		            			}  
		        			}
	        			}
	        		}
	         
	        	});
	            rb.button.setOnLongClickListener(new OnLongClickListener()
	        	{
					@Override
	        		public boolean onLongClick(View v)
	        		{
						if (EditMode)
						{
							int id = v.getId();
		        			int button_idx = id - 2000 - 100 * fragno;
	        				RemoteButton rbclicked = remote_buttons[BUTTONS * fragno + button_idx]; 

		        			if (rbclicked.visible)
		        			{
		        				deleteButton (button_idx);
			        			// Toast.makeText(MainActivityContext, "Unsichtbar", Toast.LENGTH_SHORT).show();
		        			}
						}

	        			return true;
	        		}
	        	});
	             
	            xl.addView(rb.button);

    			ViewGroup.LayoutParams params = rb.button.getLayoutParams();

    			if (rb.visible)
	            {
		            params.height = ViewGroup.LayoutParams.WRAP_CONTENT;
	            }
	            else
	            {
		            params.height = HEIGHT_INVISIBLE_BUTTON;
	            }

	            rb.button.setLayoutParams(params);
        	}
        	ll.addView(xl);
        }

        sv.setBackgroundColor(Color.BLACK);

        sv.addView(ll);

		setEditMode (EditMode);

        return sv;
    }

    public void setEditMode (boolean edit)
	{
		ViewGroup.LayoutParams		params; 
		EditMode = edit;

		if (edit)
		{
			etpagetext.setText(tvpagetext.getText ());
			((MainActivity) (MainActivityContext)).setMenusEnabled (false);

            SaveButton.setVisibility(View.VISIBLE);
			params = SaveButton.getLayoutParams();
            params.height = ViewGroup.LayoutParams.WRAP_CONTENT;
            SaveButton.setLayoutParams(params);

            tvpagetext.setVisibility(View.INVISIBLE);
			params = tvpagetext.getLayoutParams();
            params.height = 1;
            tvpagetext.setLayoutParams(params);

	        etpagetext.setVisibility(View.VISIBLE);
			params = etpagetext.getLayoutParams();
	        params.height = ViewGroup.LayoutParams.WRAP_CONTENT;
	        etpagetext.setLayoutParams(params);

            for (int bidx = 0; bidx < BUTTONS; bidx++)
        	{
            	RemoteButton rb = remote_buttons[BUTTONS * fragno + bidx]; 

            	if (! rb.visible)
	            {
        			params = rb.button.getLayoutParams();
		            params.height = ViewGroup.LayoutParams.WRAP_CONTENT;
		            rb.button.setLayoutParams(params);
	            }
        	}
		}
		else
		{
			((MainActivity) (MainActivityContext)).setMenusEnabled (true);

	        SaveButton.setVisibility(View.INVISIBLE);
			params = SaveButton.getLayoutParams();
            params.height = 1;
            SaveButton.setLayoutParams(params);

            tvpagetext.setVisibility(View.VISIBLE);
			params = tvpagetext.getLayoutParams();
            params.height = ViewGroup.LayoutParams.WRAP_CONTENT;
            tvpagetext.setLayoutParams(params);

            etpagetext.setVisibility(View.INVISIBLE);
			params = etpagetext.getLayoutParams();
            params.height = 1;
            etpagetext.setLayoutParams(params);

            for(int bidx = 0; bidx < BUTTONS; bidx++)
        	{
            	RemoteButton rb = remote_buttons[BUTTONS * fragno + bidx]; 
                if (! rb.visible)
                {
        			params = remote_buttons[BUTTONS * fragno + bidx].button.getLayoutParams();
    	            params.height = HEIGHT_INVISIBLE_BUTTON;
    	            remote_buttons[BUTTONS * fragno + bidx].button.setLayoutParams(params);
                }
        	}
		}
	}
	
	private void editButton (int bidx)
	{
	    Button[]			b		= new Button[9];
		String[]			servernames;
	    final int			PADDING = 20;
	    final EditText		tvae;
	    final EditText		tvke;
	    final EditText		t;
	    int					x;
	    int					y;
	    int					width;
	    int					idx;

        r = getResources();
        width = (int) (TypedValue.applyDimension(TypedValue.COMPLEX_UNIT_DIP, 100, r.getDisplayMetrics()) + 0.5);

        current_idx					= bidx;
        RemoteButton rb				= remote_buttons[BUTTONS * fragno + bidx];
		current_text				= rb.text;
		current_color				= rb.color;
		current_IrmpData.serveridx	= rb.serveridx;
		current_IrmpData.protocol	= rb.protocol;
		current_IrmpData.address	= rb.address;
		current_IrmpData.command	= rb.command;
		current_IrmpData.flags		= rb.flags;

	    // ((MainActivity) (MainActivityContext)).myfind
	    AlertDialog.Builder alertbox = new AlertDialog.Builder(MainActivityContext);
	    // alertbox.setMessage("Schaltflche bearbeiten");

        ScrollView sv = new ScrollView(MainActivityContext);
        LinearLayout ll = new LinearLayout(MainActivityContext);
        ll.setOrientation(LinearLayout.VERTICAL);

    	LinearLayout xlt = new LinearLayout(MainActivityContext);
    	xlt.setOrientation(LinearLayout.HORIZONTAL);

		TextView tv = new TextView(MainActivityContext);
        tv.setText("Text:");
        tv.setTextColor(Color.WHITE);
        tv.setWidth (width);
        xlt.addView(tv);

        t = new EditText(MainActivityContext);
        t.setText(current_text);
        t.setTextColor(Color.WHITE);
        t.setBackgroundColor(Color.TRANSPARENT);
        t.setWidth (width);
		xlt.addView(t);

		ll.addView (xlt);

    	TextView tvs = new TextView(MainActivityContext);
        tvs.setText("Server:");
        tvs.setTextColor(Color.WHITE);
        tvs.setWidth (width);
        ll.addView(tvs);

        final Spinner server_sp = new Spinner(MainActivityContext);

        servernames = new String[MainActivity.nServers];
        
        for (int i = 0; i < MainActivity.nServers; i++)
        {
        	servernames[i] = new String (MainActivity.irmp_server[i].name);
        }

        ArrayAdapter<String> server_adapter = new ArrayAdapter<String> (MainActivityContext, android.R.layout.simple_spinner_item, servernames);
        server_adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        server_sp.setAdapter(server_adapter);

        server_sp.setOnItemSelectedListener(new OnItemSelectedListener()
        {
			public void onItemSelected(AdapterView<?> arg0, View arg1, int arg2, long arg3)
			{
				int idx = server_sp.getSelectedItemPosition();
					
				current_IrmpData.serveridx = idx;
				// Toast.makeText(MainActivityContext, "Selected: [" + idx + "] ", Toast.LENGTH_SHORT).show();
			}

			public void onNothingSelected(AdapterView<?> arg0)
			{
			}
        });

        if (current_IrmpData.serveridx < MainActivity.nServers)
        {
        	server_sp.setSelection (current_IrmpData.serveridx);
        }
        else
        {
        	server_sp.setSelection (0);
        }
		server_sp.setBackgroundColor (Color.LTGRAY);


        ll.addView(server_sp);

    	TextView tvp = new TextView(MainActivityContext);
        tvp.setText("Protokoll:");
        tvp.setTextColor(Color.WHITE);
        tvp.setWidth (width);
        ll.addView(tvp);

        final Spinner protocols_sp = new Spinner(MainActivityContext);

       	ArrayAdapter<String> protocols_adapter = new ArrayAdapter<String> (MainActivityContext, android.R.layout.simple_spinner_item, IrmpData.protocols);
       	protocols_adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        protocols_sp.setAdapter(protocols_adapter);

        protocols_sp.setOnItemSelectedListener(new OnItemSelectedListener()
        {
			public void onItemSelected(AdapterView<?> arg0, View arg1, int arg2, long arg3)
			{
				int idx = protocols_sp.getSelectedItemPosition();
					
				current_IrmpData.protocol = idx;
				// Toast.makeText(MainActivityContext, "Selected: [" + idx + "] ", Toast.LENGTH_SHORT).show();
			}

			public void onNothingSelected(AdapterView<?> arg0)
			{
			}
        });

        if (current_IrmpData.protocol < IrmpData.n_protocols)
        {
        	protocols_sp.setSelection (current_IrmpData.protocol);
        }
        else
        {
        	protocols_sp.setSelection (0);
        }

        protocols_sp.setBackgroundColor (Color.LTGRAY);

        ll.addView(protocols_sp);

    	LinearLayout xla = new LinearLayout(MainActivityContext);
    	xla.setOrientation(LinearLayout.HORIZONTAL);

    	TextView tva = new TextView(MainActivityContext);
        tva.setText("Adresse:");
        tva.setTextColor(Color.WHITE);
        tva.setWidth (width);
        xla.addView(tva);

        tvae = new EditText(MainActivityContext);
        tvae.setText(String.valueOf(current_IrmpData.address));
        tvae.setTextColor(Color.WHITE);
        tvae.setBackgroundColor(Color.TRANSPARENT);
        tvae.setWidth (width);
        tvae.setInputType(InputType.TYPE_CLASS_NUMBER);
		xla.addView(tvae);

		ll.addView (xla);

    	LinearLayout xlk = new LinearLayout(MainActivityContext);
    	xlk.setOrientation(LinearLayout.HORIZONTAL);

    	TextView tvk = new TextView(MainActivityContext);
        tvk.setText("Kommando:");
        tvk.setTextColor(Color.WHITE);
        tvk.setWidth (width);
        xlk.addView(tvk);

        tvke = new EditText(MainActivityContext);
        tvke.setText(String.valueOf(current_IrmpData.command));
        tvke.setTextColor(Color.WHITE);
        tvke.setBackgroundColor(Color.TRANSPARENT);
        tvke.setWidth (width);
        tvke.setInputType(InputType.TYPE_CLASS_NUMBER);
		xlk.addView(tvke);

		ll.addView (xlk);

    	LinearLayout xlf = new LinearLayout(MainActivityContext);
    	xlf.setOrientation(LinearLayout.HORIZONTAL);

		TextView tvf = new TextView(MainActivityContext);
        tvf.setText("Farbe:");
        tvf.setTextColor(Color.WHITE);
        tvf.setWidth (width);
        xlf.addView(tvf);

		final Button f = new Button(MainActivityContext);
        f.setTextColor (Color.WHITE);
        f.setText("");
        f.getBackground().setColorFilter(new LightingColorFilter(RemoteButton.MUL[current_color], RemoteButton.COL[current_color]));
        xlf.addView(f);

        ll.addView (xlf);

        int cols	= 3;
        int lines	= (RemoteButton.BUTTON_COLORS - 1) / cols + 1;
        
        for (y = 0; y < lines; y++)
    	{
        	LinearLayout xl = new LinearLayout(MainActivityContext);
        	xl.setOrientation(LinearLayout.HORIZONTAL);
        	xl.setGravity(Gravity.CENTER_HORIZONTAL);
        	// xl.setBackgroundColor(Color.BLACK);

        	for (x = 0; x < cols; x++)
        	{
        		idx = cols * y + x;
        		b[idx] = new Button(MainActivityContext);
	            b[idx].setId(idx + 3000);
	            b[idx].setTextColor (Color.WHITE);
	            b[idx].setText("");
	            b[idx].getBackground().setColorFilter(new LightingColorFilter(RemoteButton.MUL[idx], RemoteButton.COL[idx]));
	            b[idx].setOnClickListener(new OnClickListener()
	          	{
	        		@Override
	        		public void onClick(View v)
	        		{
	        			int button_idx = v.getId() - 3000;
	          		   	current_color = button_idx;
	          	        f.getBackground().setColorFilter(new LightingColorFilter(RemoteButton.MUL[current_color], RemoteButton.COL[current_color]));
	    				f.invalidate ();			// force redraw of f
	        		}
	          	});
	
	            xl.addView(b[idx]);
        	}

            ll.addView(xl);
    	}

        Button learn = new Button(MainActivityContext);
        learn.setTextColor (Color.WHITE);
        learn.setText("Anlernen");
        learn.setOnClickListener(new OnClickListener()
      	{
    		@Override
    		public void onClick(View v)
    		{
    		    final int server_port = MainActivity.irmp_server[current_IrmpData.serveridx].port;  
    		    DatagramSocket s;
    		    String message = "r";

    		    try
    			{
    				s = new DatagramSocket();

    				final InetAddress RemoteServer = InetAddress.getByName(MainActivity.irmp_server[current_IrmpData.serveridx].ipaddress);  
    			      
    			    byte[] messageBytes = message.getBytes();  
    			    int msg_length = messageBytes.length;
    			    // int msg_length = message.length();									// falsch fr Umlaute!  
    			    
    			    DatagramPacket p = new DatagramPacket(messageBytes, msg_length, RemoteServer, server_port);  
    			      
    			    s.send(p);
    			    
    			    byte[] receiveData = new byte[8];

    			    s.setSoTimeout(10000);   // set the timeout in millisecounds.
    	            DatagramPacket receivePacket = new DatagramPacket(receiveData, receiveData.length);
    			    
    			    try
    			    {
    			    	s.receive(receivePacket);

    			    	if (receivePacket.getLength() == 8)
    			    	{
    			    		if (receiveData[0] == 'S' && receiveData[1] == '+')
    			    		{
		    			    	// mask byte with 0xFF to avoid sign extension!
		    			    	current_IrmpData.protocol = receiveData[2] & 0xFF;
		    			    	current_IrmpData.address  = ((receiveData[3] & 0xFF) << 8) + (receiveData[4] & 0xFF);
		    			    	current_IrmpData.command  = ((receiveData[5] & 0xFF) << 8) + (receiveData[6] & 0xFF);
		    			    	current_IrmpData.flags    = (receiveData[7] & 0xFF);
		
		    			    	if (current_IrmpData.protocol < IrmpData.n_protocols)
		    			    	{
		    			    		protocols_sp.setSelection (current_IrmpData.protocol);
		    			    	}
		    			    	else
		    			    	{
		    			    		protocols_sp.setSelection (0);
		    			    	}
		    	            
		    			    	tvae.setText(String.valueOf(current_IrmpData.address));
		    			    	tvke.setText(String.valueOf(current_IrmpData.command));
    			    		}
    			    		else
    			    		{
    	    			    	Toast.makeText(MainActivityContext.getApplicationContext(), "Antwort: Anlernzeit abgelaufen!", Toast.LENGTH_SHORT).show();
    			    		}
    			    	}
    			    	else
    			    	{
        			    	Toast.makeText(MainActivityContext.getApplicationContext(), "Kommunikationsfehler!", Toast.LENGTH_SHORT).show();
    			    	}
    			    }
    			    catch (SocketTimeoutException e)
    			    {
    			    	Toast.makeText(MainActivityContext.getApplicationContext(), "Keine Antwort!", Toast.LENGTH_SHORT).show();
    	            }
   			    	s.close();
    			}
    			catch (SocketException e)
    			{
			    	Toast.makeText(MainActivityContext.getApplicationContext(), "Socket Exception!", Toast.LENGTH_SHORT).show();
    				// e.printStackTrace();
    			}
    		    catch (UnknownHostException e)
    			{
			    	Toast.makeText(MainActivityContext.getApplicationContext(), "Unknown host!", Toast.LENGTH_SHORT).show();
    				// e.printStackTrace();
    			}
    		    catch (IOException e)
    		    {
			    	Toast.makeText(MainActivityContext.getApplicationContext(), "IO exception!", Toast.LENGTH_SHORT).show();
    				// e.printStackTrace();
    			}  
    		}
      	});
	
        ll.addView(learn);

        sv.addView(ll);
        sv.setBackgroundColor(Color.rgb(25, 25, 25));
        int padding_px = (int) (TypedValue.applyDimension(TypedValue.COMPLEX_UNIT_DIP, PADDING, r.getDisplayMetrics()) + 0.5);
        sv.setPadding(padding_px, 0, padding_px, 0);
        alertbox.setView (sv);

	    alertbox.setPositiveButton("Ok", new DialogInterface.OnClickListener()
	    {
	        public void onClick(DialogInterface arg0, int arg1)
	        {
				current_text = t.getText().toString().trim();

				if (current_text.contentEquals(""))
				{
					Toast.makeText(MainActivityContext.getApplicationContext(), "Text muss ausgefllt werden!", Toast.LENGTH_SHORT).show();
					current_text = "...";
				}
				else
				{
					String s;

					SetButton (fragno, current_idx, true, current_text, current_color);
					RemoteButton rbclicked = remote_buttons[BUTTONS * fragno + current_idx]; 

					rbclicked.button.setText (current_text);
					rbclicked.button.getBackground().setColorFilter(
							new LightingColorFilter(RemoteButton.MUL[rbclicked.color], RemoteButton.COL[rbclicked.color]));

					rbclicked.serveridx	= current_IrmpData.serveridx;
					rbclicked.protocol	= current_IrmpData.protocol;
					
					s = tvae.getText().toString().trim();

					if (s == "")
					{
						rbclicked.address = 0;
					}
					else
					{
						rbclicked.address	= Integer.parseInt(s);
					}

					s = tvke.getText().toString().trim();

					if (s == "")
					{
						rbclicked.command = 0;
					}
					else
					{
						rbclicked.command = Integer.parseInt(s);
					}

					// TODO rbclicked.flags		= current_IrmpData.flags;
				}
	        }
	    });
	
	    alertbox.setNegativeButton("Abbrechen", new DialogInterface.OnClickListener()
	    {
	        public void onClick(DialogInterface arg0, int arg1)
	        {
	            ;
	        }
	    });
	    alertbox.show ();
	}

	private void deleteButton (int button_idx)
	{
		final int i = button_idx;
		
		AlertDialog.Builder alertbox = new AlertDialog.Builder(MainActivityContext);
	    alertbox.setMessage("Schaltflche lschen?");
	
	    alertbox.setPositiveButton("Ja", new DialogInterface.OnClickListener()
	    {
	        public void onClick(DialogInterface arg0, int arg1)
	        {
				SetButton (fragno, i, false, null, RemoteButton.INVISIBLE);
				RemoteButton rb = remote_buttons[BUTTONS * fragno + i]; 

				rb.button.setText("");
				rb.button.getBackground().setColorFilter(
						new LightingColorFilter(RemoteButton.MUL[rb.color], RemoteButton.COL[rb.color]));
	        }
	    });
	
	    alertbox.setNegativeButton("Nein", new DialogInterface.OnClickListener()
	    {
	        public void onClick(DialogInterface arg0, int arg1)
	        {
	        }
	    });
	    alertbox.show ();
	}
}
